package com.lqkj.link.util;

import com.fasterxml.jackson.core.JsonGenerator;
import com.fasterxml.jackson.databind.SerializerProvider;
import com.fasterxml.jackson.databind.ser.std.StdSerializer;
import org.apache.calcite.runtime.SpatialTypeUtils;
import org.locationtech.jts.geom.Geometry;

import java.io.IOException;

public class GeometrySerializer extends StdSerializer<Geometry> {

    public GeometrySerializer() {
        this(null);
    }

    public GeometrySerializer(Class<Geometry> t) {
        super(t);
    }

    @Override
    public void serialize(Geometry geometry, JsonGenerator jsonGenerator, SerializerProvider serializerProvider) throws IOException {
        jsonGenerator.writeString(SpatialTypeUtils.asGeoJson(geometry));
    }

}